#pragma once

#include <map>
#include <string>
#include <fstream>
#include <iostream>
#include <iterator>
#include <algorithm>
#include <iomanip>

struct Date {
	int day;
	int month;
	int year;

	bool operator ==(const Date& to_compare) { 
		return (day == to_compare.day) && (month == to_compare.month) && (year == to_compare.year); 
	}

	bool operator <(const Date& to_compare) {
		if (year < to_compare.year) {
			return true;
		} else if (year == to_compare.year) {
			if (month < to_compare.month) {
				return true;
			} else if (month == to_compare.month) {
				if (day < to_compare.day) {
					return true;
				} else {
					return false;
				}
			} else {
				return false;
			}
		} else {
			return false;
		}
	}

	Date operator +(const Date& to_summ) {
		day += to_summ.day;
		while (day >= 30) {
			day = day - 30;
			month++;
		}
		month += to_summ.month;
		while (month >= 12) {
			month = month - 12;
			year++;
		}
		year += to_summ.year;
		return *this;
	}

	Date operator +(const int to_summ) {
		day += to_summ;
		while (day >= 30) {
			day = day - 30;
			month++;
		}

		while (month >= 12) {
			month = month - 12;
			year++;
		}
		return *this;
	}

	friend std::ostream& operator << (std::ostream& out, const Date& p_date) { 
		out << p_date.day << "." << p_date.month << "." << p_date.year << "\n";
		return out; 
	}
		
	friend std::istream& operator >> (std::istream& in, Date& p_date) {
		std::cout << "day = ";
		in >> p_date.day;
		std::cout << "month = ";
		in >> p_date.month;
		std::cout << "year = ";
		in >> p_date.year;
		return in;
	}
};

struct Products {
	int storageId;
	int productCode;
	char productName[50];
	Date arrivalDate;
	int shelfLife;
	int productsAmount;
	double unitPrice;

	bool operator ==(const Products& prod_to_comp) {
		return storageId == prod_to_comp.storageId &&
			productCode == prod_to_comp.productCode &&
			strcmp(productName, prod_to_comp.productName) &&
			arrivalDate == prod_to_comp.arrivalDate &&
			shelfLife == prod_to_comp.shelfLife &&
			productsAmount == prod_to_comp.productsAmount &&
			unitPrice == prod_to_comp.unitPrice;

	}

	friend std::ostream& operator <<(std::ostream& out, const Products& P) {
		out  << P.storageId 
			<< " " << P.productCode 
			<< " " << P.productName 
			<< " " << P.arrivalDate 
			<< " " << P.shelfLife 
			<< " " << P.productsAmount 
			<< " " << P.unitPrice ;
		return out;
	}

	friend std::istream& operator >>(std::istream& in, Products& P) {
		std::cout << "Storage Id =  ";
		in >> P.storageId;
		std::cout << "Product Code =   ";
		in >> P.productCode;
		std::cout << "Product Name =   ";
		in >> P.productName;
		std::cout << "Arrival Date = ";
		in >> P.arrivalDate;
		std::cout << "Shelf Life =   ";
		in >> P.shelfLife;
		std::cout << "Products Amount =   ";
		in >> P.productsAmount;
		std::cout << "Unit Price =   ";
		in >> P.unitPrice;
		return in;
	}
};


class Reg {
	std::map<size_t, Products> product;
	std::string binName;
	std::string txtName;
	size_t amount;
	static void newProduct(Products& tmp_prod);
	void load();

public:
	Reg(const std::string& bin_f, const std::string& txt_to_out);
	~Reg();

	void createAndWrite();
	void printData()  noexcept;
	void printProduct(const std::pair<size_t, Products>& prod);
	void updateFile();
	void addProduct();
	void dropProduct(int prod_id);
	void changeProduct(int prod_id);
	void findStorageId(int id) noexcept;
	void findProductCode(int code) noexcept;
	void findArrivalDate(const Date& arr_date) noexcept;
	void findOverdueProducts(const Date& curr_date) noexcept;
	void findNotOverdueProducts(const Date& curr_date) noexcept;
	void loadOutputTxtFile();
};
